auction_umbrella/apps/auction_web/lib/auction_web/router.ex
defmodule AuctionWeb.Router do
  use AuctionWeb, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
    plug AuctionWeb.Authenticator
  end

  pipeline :api do
    plug :accepts, ["json"]
  end

  scope "/", AuctionWeb do
    pipe_through :browser

    get "/", PageController, :index

    resources "/items", ItemController, only: [:index, :show, :new, :create, :edit, :update] do
      resources "/bids", BidController, only: [:create]
    end

    resources "/users", UserController, only: [:show, :new, :create]

    get "/login", SessionController, :new
    post "/login", SessionController, :create
    delete "/logout", SessionController, :delete
  end

  # Other scopes may use custom stacks.
  scope "/api", AuctionWeb do
    pipe_through :api

    resources "/items", ItemController, only: [:index, :show]
  end
end

auction_umbrella/apps/auction_web/lib/auction_web/controllers/api/item_controller.ex
defmodule AuctionWEb.Api.ItemController do
  use AuctionWeb, :controller

  def index(conn, _params) do
    items = Auction.list_items()
    render(conn, "index.json", items: items)
  end

  def show(conn, %{"id" => id}) do
    item = Auction.get_item_with_bids(id)
    render(conn, "show.json", item: item)
  end
end

auction_umbrella/apps/auction_web/lib/auction_web/controllers/bid_controller.ex
defmodule AuctionWeb.BidController do
  use AuctionWeb, :controller

  plug :require_logged_in_user

  def create(conn, %{"bid" => %{"amount" => amount}, "item_id" => item_id}) do
    case Auction.insert_bid(%{
           amount: amount,
           item_id: item_id,
           user_id: conn.assigns.current_user.id
         }) do
      {:ok, bid} ->
        html =
          Phoenix.View.render_to_string(
            AuctionWeb.BidView,
            "bid.html",
            bid: bid,
            username: conn.assigns.current_user.username
          )

        AuctionWeb.Endpoint.broadcast("item:#{item_id}", "new_bid", %{body: html})

        redirect(conn, to: Routes.item_path(conn, :show, bid.item_id))

      {:error, bid} ->
        item = Auction.get_item(item_id)
        render(conn, AuctionWeb.ItemView, "show.html", item: item, bid: bid)
    end
  end

  defp require_logged_in_user(%{assigns: %{current_user: nil}} = conn, _opts) do
    conn
    |> put_flash(:error, "Nice try, friend. You must be logged in to bid.")
    |> redirect(to: Routes.item_path(conn, :index))
    |> halt()
  end

  defp require_logged_in_user(conn, _opts), do: conn
end

auction_umbrella/apps/auction_web/lib/auction_web/controllers/item_controller.ex
defmodule AuctionWeb.ItemController do
  use AuctionWeb, :controller

  def index(conn, _params) do
    items = Auction.list_items()
    render(conn, "index.html", items: items)
  end

  def show(conn, %{"id" => id}) do
    item = Auction.get_item_with_bids(id)
    bid = Auction.new_bid()
    render(conn, "show.html", item: item, bid: bid)
  end

  def new(conn, _params) do
    item = Auction.new_item()
    render(conn, "new.html", item: item)
  end

  def create(conn, %{"item" => item_params}) do
    case Auction.insert_item(item_params) do
      {:ok, item} -> redirect(conn, to: Routes.item_path(conn, :show, item))
      {:error, item} -> render(conn, "new.html", item: item)
    end
  end

  def edit(conn, %{"id" => id}) do
    item = Auction.edit_item(id)
    render(conn, "edit.html", item: item)
  end

  def update(conn, %{"id" => id, "item" => item_params}) do
    item = Auction.get_item(id)

    case Auction.update_item(item, item_params) do
      {:ok, item} -> redirect(conn, to: Routes.item_path(conn, :show, item))
      {:error, item} -> render(conn, "edit.html", item: item)
    end
  end
end

auction_umbrella/apps/auction_web/lib/auction_web/controllers/page_controller.ex
defmodule AuctionWeb.PageController do
  use AuctionWeb, :controller

  def index(conn, _params) do
    items = Auction.list_items()
    render(conn, "index.html", items: items)
  end
end

auction_umbrella/apps/auction_web/lib/auction_web/controllers/session_controller.ex
defmodule AuctionWeb.SessionController do
  use AuctionWeb, :controller

  def new(conn, _params) do
    render(conn, "new.html")
  end

  def create(conn, %{"user" => %{"username" => username, "password" => password}}) do
    case Auction.get_user_by_username_and_password(username, password) do
      %Auction.User{} = user ->
        conn
        |> put_session(:user_id, user.id)
        |> put_flash(:info, "Sucessfully logged in")
        |> redirect(to: Routes.user_path(conn, :show, user))

      _ ->
        conn
        |> put_flash(:error, "That username and password combination cannot be found")
        |> render("new.html")
    end
  end

  def delete(conn, _params) do
    conn
    |> clear_session()
    |> configure_session(drop: true)
    |> redirect(to: Routes.item_path(conn, :index))
  end
end

auction_umbrella/apps/auction_web/lib/auction_web/controllers/user_controller.ex
defmodule AuctionWeb.UserController do
  use AuctionWeb, :controller
  plug :prevent_unauthorized_access when action in [:show]

  def show(conn, %{"id" => id}) do
    user = Auction.get_user(id)
    bids = Auction.get_bids_for_user(user)
    render(conn, "show.html", user: user, bids: bids)
  end

  def new(conn, _params) do
    user = Auction.new_user()
    render(conn, "new.html", user: user)
  end

  def create(conn, %{"user" => user_params}) do
    case Auction.insert_user(user_params) do
      {:ok, user} -> redirect(conn, to: Routes.user_path(conn, :show, user))
      {:error, user} -> render(conn, "new.html", user: user)
    end
  end

  defp prevent_unauthorized_access(conn, _opts) do
    current_user = Map.get(conn.assigns, :current_user)

    requested_user_id =
      conn.params
      |> Map.get("id")
      |> String.to_integer()

    if current_user == nil || current_user.id != requested_user_id do
      conn
      |> put_flash(:error, "Nice try, friend. Thast's not a page for you.")
      |> redirect(to: Routes.item_path(conn, :index))
      |> halt()
    else
      conn
    end
  end
end

auction_umbrella/apps/auction_web/lib/auction_web/views/bid_view.ex
defmodule AuctionWeb.BidView do
  use AuctionWeb, :view
end

auction_umbrella/apps/auction_web/lib/auction_web/views/error_view.ex
defmodule AuctionWeb.ErrorView do
  use AuctionWeb, :view

  # If you want to customize a particular status code
  # for a certain format, you may uncomment below.
  # def render("500.html", _assigns) do
  #   "Internal Server Error"
  # end

  # By default, Phoenix returns the status message from
  # the template name. For example, "404.html" becomes
  # "Not Found".
  def template_not_found(template, _assigns) do
    Phoenix.Controller.status_message_from_template(template)
  end
end

auction_umbrella/apps/auction_web/lib/auction_web/views/item_view.ex
defmodule AuctionWeb.ItemView do
  use AuctionWeb, :view
end

auction_umbrella/apps/auction_web/lib/auction_web/views/layout_view.ex
defmodule AuctionWeb.LayoutView do
  use AuctionWeb, :view
end

auction_umbrella/apps/auction_web/lib/auction_web/views/page_view.ex
defmodule AuctionWeb.PageView do
  use AuctionWeb, :view
end

auction_umbrella/apps/auction_web/lib/auction_web/views/session_view.ex
defmodule AuctionWeb.SessionView do
  use AuctionWeb, :view
end

auction_umbrella/apps/auction_web/lib/auction_web/views/user_view.ex
defmodule AuctionWeb.UserView do
  use AuctionWeb, :view
end

auction_umbrella/apps/auction_web/lib/auction_web/templates/bid/bid.html.eex
<p>
<%= integer_to_currency(@bid.amount) %>
<em>from <%= Map.get(@bid.user, :username) || @username %></em>
</p>

auction_umbrella/apps/auction_web/lib/auction_web/templates/item/edit.html.eex
<h1>Edit <%= @item.data.title %></h1>

<%= render("form.html", item: @item, action: Routes.item_path(@conn, :update, @item.data)) %>

auction_umbrella/apps/auction_web/lib/auction_web/templates/item/form.html.eex
<%= form_for @item, @action, fn f -> %>            
  <%= if @item.action do %>
    <div class="alert alert-danger">
      Unfortunately, there are errors in your
      submission. Please correct them below.
    </div>
  <% end %>

  <%= label f, :title %>
  <%= text_input f, :title %>
  <%= error_tag f, :title %>

  <%= label f, :description %>
  <%= textarea f, :description %>
  <%= error_tag f, :description %>

  <%= label f, :ends_at, "Auction ends at" %>
  <%= datetime_select f, :ends_at %>
  <%= error_tag f, :ends_at %>

  <div>
    <%= submit "Submit" %>
  </div>
<% end %>

auction_umbrella/apps/auction_web/lib/auction_web/templates/item/index.html.eex
<%= link "New item", to: Routes.item_path(@conn, :new) %>

<ul>
    <%= for item <- @items do %>
        <li><strong><%= link(item.title, to: Routes.item_path(@conn, :show, item))%> - <%=item.description%></li>
    <% end %>
</ul>

auction_umbrella/apps/auction_web/lib/auction_web/templates/item/new.html.eex
<h1>New Item</h1>

<%= render("form.html", item: @item, action: Routes.item_path(@conn, :create)) %>

auction_umbrella/apps/auction_web/lib/auction_web/templates/item/show.html.eex
<h1><%= @item.title %></h1>
<ul>
    <li><strong>Description:</strong> <%= @item.description %></li>
    <li><strong>Auction ends at:</strong> <%= @item.ends_at %></li>
</ul>

<div style="display: flex; flex-direction: row;">
    <div style="flex: 1;">

<h2>Current bids</h2>
<div id="bids">
<%= render_many @item.bids, AuctionWeb.BidView, "bid.html" %>
</div>
    </div>
    <div style="flex: 1;">
    <%= if @current_user do %>
        <h2>Place your bid!</h2>
        <%= form_for @bid, Routes.item_bid_path(@conn, :create, @item), fn f -> %>
            <%= if @bid.action do %>
                <div class="alert alert-danger">
                Unfortunately, there are errors in your
                submission. Please correct them below.
                </div>
            <% end %>
        <div class="form-group">
            <%= label f, :amount, "Bid amount", class: "control-label" %>
            <%= error_tag f, :amount %>
            <%= number_input f, :amount, class: "form-control" %>
        </div>
        <%= submit "Submit", class: "btn btn-primary"%>
        <% end %>
    <% end %>
    </div>
</div>

auction_umbrella/apps/auction_web/lib/auction_web/templates/layout/app.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>AuctionWeb · Phoenix Framework</title>
    <link rel="stylesheet" href="<%= Routes.static_path(@conn, "/css/app.css") %>"/>
  </head>
  <body>
    <header>
      <section class="container">
        <nav role="navigation">
          <ul>
            <li><a href="https://hexdocs.pm/phoenix/overview.html">Get Started</a></li>
          </ul>
        </nav>
        <a href="http://phoenixframework.org/" class="phx-logo">
          <img src="<%= Routes.static_path(@conn, "/images/phoenix.png") %>" alt="Phoenix Framework Logo"/>
        </a>
      </section>
    </header>
    
    <div class="container" style="border-bottom: 1px solid #777777; margin-bottom: 2rem; padding-bottom: 1rem;">
      <%= link "Items", to: Routes.item_path(@conn, :index) %>
      <%= if @current_user do %>
        Logged in as <%= link @current_user.username, to: Routes.user_path(@conn, :show, @current_user) %>
        <%= link "Log out", to: Routes.session_path(@conn, :delete), method: :delete %>
      <% else %>
        <%= link "login", to: Routes.session_path(@conn, :new) %>
      <% end %>
    </div>

    <main role="main" class="container">
      <p class="alert alert-info" role="alert"><%= get_flash(@conn, :info) %></p>
      <p class="alert alert-danger" role="alert"><%= get_flash(@conn, :error) %></p>
      <%= render @view_module, @view_template, assigns %>
    </main>
    <script type="text/javascript" src="<%= Routes.static_path(@conn, "/js/app.js") %>"></script>
  </body>
</html>

auction_umbrella/apps/auction_web/lib/auction_web/templates/page/index.html.eex
<ul>
  <%= for item <- @items do %>
    <li>
      <strong><%= item.title %></strong>: <%= item.description %>
     </li> 
   <% end %>   
</ul>

auction_umbrella/apps/auction_web/lib/auction_web/templates/session/new.html.eex
<h1>Log In</h1>

<%= form_for @conn, Routes.session_path(@conn, :create), [as: :user], fn f -> %>
    <%= label f, :username %>
    <%= text_input f, :username %>
    <%= label f, :password %>
    <%= password_input f, :password %>
    
    <div>
    <%= submit "Submit" %>
    </div>

<% end %>

<%= link "New user", to: Routes.user_path(@conn, :new) %>

auction_umbrella/apps/auction_web/lib/auction_web/templates/user/new.html.eex
<h1>User Registration</h1>

<%= form_for @user, Routes.user_path(@conn, :create), fn f -> %>

<%= if @user.action do %>
    <div class="alert alert-danger">
    Unfortunately, there are errors in your submission.
    Please correct them below.
    </div>
<% end %>

<%= label f, :username %>
<%= error_tag f, :username %>
<%= text_input f, :username %>

<%= label f, :email_address %>
<%= error_tag f, :email_address %>
<%= text_input f, :email_address %>

<%= label f, :password %>
<%= error_tag f, :password %>
<%= password_input f, :password %>

<%= label f, :password_confirmation %>
<%= error_tag f, :password_confirmation %>
<%= password_input f, :password_confirmation %>

<div>
<%= submit "Submit" %>
</div>
<% end %>

auction_umbrella/apps/auction_web/lib/auction_web/templates/user/show.html.eex
<h1>User details</h1>

<dl>
    <dt>Username</dt>
    <dd><%= @user.username %></dd>
    <br />
    <dt>Email address</dt>
    <dd><%= @user.email_address %></dd>
</dl>

<h2>Recent bids</h2>
<%= for bid <- @bids do %>
    <p>
        <strong><%= formatted_datetime(bid.inserted_at) %></strong>
        --
        <%= integer_to_currency(bid.amount) %>
        for
        <em><%= link bid.item.title, to: Routes.item_path(@conn, :show, bid.item)%></em>
    </p>
<% end %>